---
title: RTCDTMFSender.insertDTMF()
slug: Web/API/RTCDTMFSender/insertDTMF
tags:
  - API
  - DTMF
  - Media
  - Method
  - RTCDTMFSender
  - Reference
  - Telephony
  - Touch-tone
  - WebRTC
  - WebRTC API
  - insertDTMF
---
<p>{{APIRef("WebRTC")}}</p>

<p><span class="seoSummary">The <code><strong>insertDTMF</strong></code><strong><code>()</code></strong> method on the {{domxref("RTCDTMFSender")}} interface starts sending </span>{{Glossary("DTMF")}}<span class="seoSummary"> tones to the remote peer over the {{domxref("RTCPeerConnection")}}. Sending of the tones is performed asynchronously, with {{event("tonechange")}} events sent to the <code>RTCDTMFSender</code> every time a tone starts or ends.</span></p>

<p>As long as the connection is active, you can send tones at any time. Calling <code>insertDTMF()</code> will append the specified tones to the end of the current tone buffer, so that those tones play after the previously-enqueued tones.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>RTCDTMFSender</em>.insertDTMF(<em>tones</em>[, <em>duration</em>[, <em>interToneGap</em>]]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>tones</code></dt>
 <dd>A {{domxref("DOMString")}} containing the DTMF codes to be transmitted to the recipient. Specifying an empty string as the <code>tones</code> parameter clears the tone buffer, aborting any currently queued tones. A "," character inserts a two second delay.</dd>
 <dt><code>duration</code> {{optional_inline}}</dt>
 <dd>The amount of time, in milliseconds, that each DTMF tone should last. This value must be between 40 ms and 6000 ms (6 seconds), inclusive. The default is 100 ms.</dd>
 <dt><code>interToneGap</code> {{optional_inline}}</dt>
 <dd>The length of time, in milliseconds, to wait between tones. The browser will enforce a minimum value of 30 ms (that is, if you specify a lower value, 30 ms will be used instead); the default is 70 ms.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The DTMF tones couldn't be sent because the track has been stopped, or is in a read-only or inactive state.</dd>
 <dt><code>InvalidCharacterError</code></dt>
 <dd>One or more of the characters in <code>tones</code> is not valid DTMF.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>tbd</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-RTCDTMFSender-insertDTMF', 'RTCDTMFSender.insertDTMF()') }}</td>
   <td>{{Spec2("WebRTC 1.0")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCDTMFSender.insertDTMF")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Using_DTMF">Using DTMF with WebRTC</a></li>
 <li>{{domxref("RTCPeerConnection")}}</li>
 <li>{{domxref("RTCDTMFSender")}}</li>
 <li>{{domxref("RTCRtpSender")}}</li>
</ul>
